Do not do SpecConstr on functions that unconditionally diverge
[ghc.git] / Makefile
index 7adec86..80f8b3f 100644 (file)
--- a/Makefile
+++ b/Makefile
@@ -72,23 +72,14 @@ else
 SUBDIRS_BUILD = includes utils driver docs compiler libraries/Cabal/doc
 endif
 
-SUBDIRS = gmp libffi includes utils driver docs rts compiler ghc libraries libraries/Cabal/doc
+SUBDIRS = gmp libffi includes utils docs rts compiler ghc driver libraries libraries/Cabal/doc
 
-check-all: check-tools check-packages
-
-check-tools:
-       @:
-ifeq "$(HADDOCK_DOCS)" "YES"
-ifeq "$(HADDOCK)"      ""
-       echo "Couldn't find haddock" >&2
-       exit 1
-endif
-endif
+check-all: check-packages check-tools
 
 # Sanity check that all the boot libraries are in the tree, to catch
 # failure to run darcs-all.
 check-packages :
-       @ds=`grep "^[^# ][^ ]*  *[^ ][^ ]*$$" packages | sed "s/ .*//"`;\
+       @ds=`grep "^[^# ][^ ]*  *[^ ][^ ]*  *[^ ][^ ]*$$" packages | sed "s/ .*//"`;\
        for d in $$ds; do \
          if test ! -d $$d; then \
             echo "Looks like you're missing $$d,"; \
@@ -102,6 +93,21 @@ check-packages :
            exit 1; \
        fi
 
+HAVE_EVAL := NO
+$(eval HAVE_EVAL := YES)
+
+check-tools:
+ifeq "$(HSCOLOUR_SRCS) $(HSCOLOUR)" "YES "
+       @echo "HsColour needed but wasn't found."
+       @echo "Set HSCOLOUR_SRCS=NO if you don't want to use it"
+       exit 1
+endif
+ifeq "$(HAVE_EVAL)" "NO"
+       @echo "Your make doesn't support eval. You need GNU make >= 3.80"
+       exit 1
+endif
+       @:
+
 ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
 ifneq "$(WhatGccIsCalled)" ""
 GCC_LIB_DEP = stamp.inplace-gcc-lib
@@ -111,7 +117,6 @@ endif
 stage1 : $(GCC_LIB_DEP) check-all
        $(MAKE) -C libraries boot
        $(MAKE) -C gmp       all
-       $(MAKE) -C libffi    all
        $(MAKE) -C utils/mkdependC boot
        $(MAKE) -C utils with-bootstrapping-compiler
        @case '${MFLAGS}' in *-[ik]*) x_on_err=0;; *-r*[ik]*) x_on_err=0;; *) x_on_err=1;; esac; \
@@ -131,10 +136,10 @@ stage1 : $(GCC_LIB_DEP) check-all
          $(MAKE) --no-print-directory -C $$i $(MFLAGS) all; \
          if [ $$? -eq 0 -o $$x_on_err -eq 0 ] ;  then true; else exit 1; fi; \
        done
+       $(MAKE) -C libffi    all
        $(MAKE) -C rts boot
        $(MAKE) -C rts
        $(MAKE) -C libraries all
-       $(MAKE) -C utils with-stage-1
 
 # When making distributions (i.e., whether with binary-dist or using the 
 # vanilla install target to create an installer package), we can have problems
@@ -146,8 +151,10 @@ stage1 : $(GCC_LIB_DEP) check-all
 stage2 : check-all
        $(MAKE) -C compiler stage=2 boot
        $(MAKE) -C compiler stage=2
+       $(MAKE) -C utils with-stage-2
 ifeq "$(HADDOCK_DOCS)" "YES"
-       $(MAKE) -C compiler stage=2 doc
+       $(MAKE) -C libraries doc
+       $(MAKE) -C compiler  doc stage=2
 endif
 
 stage3 : check-all
@@ -284,7 +291,7 @@ install-docs ::
 
 binary-dist::
        -rm -rf $(BIN_DIST_DIR)
-       -$(RM) $(BIN_DIST_TARBALL)
+       -$(RM) $(BIN_DIST_TAR_BZ2)
 
 ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
 
@@ -299,6 +306,14 @@ binary-dist::
        $(MKDIRHIER) $(BIN_DIST_DIR)/icons
        cp distrib/hsicon.ico $(BIN_DIST_DIR)/icons
 
+# Tar up the distribution and build a manifest
+binary-dist :: tar-binary-dist
+
+.PHONY: tar-binary-dist
+tar-binary-dist:
+       ( cd $(BIN_DIST_TOPDIR_ABS); $(TAR) cf - $(BIN_DIST_NAME) | bzip2 > $(BIN_DIST_TAR_BZ2) )
+       ( cd $(BIN_DIST_TOPDIR_ABS); bunzip2 -c $(BIN_DIST_TAR_BZ2) | $(TAR) tf - | sed "s/^ghc-$(ProjectVersion)/fptools/" | sort >$(FPTOOLS_TOP_ABS)/bin-manifest-$(ProjectVersion) )
+
 else
 
 .PHONY: binary-dist
@@ -336,6 +351,7 @@ binary-dist::
        $(MAKE) -C driver              binary-dist WHERE_AM_I=$(WHERE_AM_I)/driver
        $(MAKE) -C utils               binary-dist WHERE_AM_I=$(WHERE_AM_I)/utils
        $(MAKE) -C docs                binary-dist WHERE_AM_I=$(WHERE_AM_I)/docs
+       $(MAKE) -C libffi              binary-dist WHERE_AM_I=$(WHERE_AM_I)/libffi
        $(MAKE) -C libraries           binary-dist WHERE_AM_I=$(WHERE_AM_I)/libraries
        $(MAKE) -C libraries/Cabal/doc binary-dist WHERE_AM_I=$(WHERE_AM_I)/libraries/Cabal/doc
 # Now thinks get messier. Some files we need to move around, rename or
@@ -382,6 +398,7 @@ endif
        echo "XSLTPROC = $(XSLTPROC)"                     >> $(BIN_DIST_VARFILE)
        echo "TARGETPLATFORM = $(TARGETPLATFORM)"         >> $(BIN_DIST_VARFILE)
        echo "HADDOCK_DOCS = $(HADDOCK_DOCS)"             >> $(BIN_DIST_VARFILE)
+       echo "LATEX_DOCS = $(LATEX_DOCS)"                 >> $(BIN_DIST_VARFILE)
        echo "INTEGER_LIBRARY = $(INTEGER_LIBRARY)"       >> $(BIN_DIST_VARFILE)
        cat distrib/Makefile-bin-vars.in                  >> $(BIN_DIST_VARFILE)
 
@@ -389,22 +406,15 @@ endif
 
        $(RM) -f $(BIN_DIST_NAME)
        ln -s . $(BIN_DIST_NAME)
-       tar cf $(BIN_DIST_TAR) -T $(BIN_DIST_LIST)
-       cd $(BIN_DIST_PREP_DIR) && tar rf $(BIN_DIST_TAR) $(BIN_DIST_NAME)
+# h means "follow symlinks", e.g. if aclocal.m4 is a symlink to a source
+# tree then we want to include the real file, not a symlink to it
+       $(TAR) hcf $(BIN_DIST_TAR) -T $(BIN_DIST_LIST)
+       cd $(BIN_DIST_PREP_DIR) && $(TAR) rf $(BIN_DIST_TAR) $(BIN_DIST_NAME)
        bzip2 < $(BIN_DIST_TAR) > $(BIN_DIST_TAR_BZ2)
-       tar tf $(BIN_DIST_TAR) | sort > bin-manifest-$(ProjectVersion)
+       $(TAR) tf $(BIN_DIST_TAR) | sort > bin-manifest-$(ProjectVersion)
 endif
 
-# XXX Presumably we still need to do this for Windows?
-## Tar up the distribution and build a manifest
-#binary-dist :: tar-binary-dist
-#
-#.PHONY: tar-binary-dist
-#tar-binary-dist:
-#      ( cd $(BIN_DIST_TOPDIR_ABS); tar cf - $(BIN_DIST_NAME) | bzip2 >$(BIN_DIST_TARBALL) )
-#      ( cd $(BIN_DIST_TOPDIR_ABS); bunzip2 -c $(BIN_DIST_TARBALL) | tar tf - | sed "s/^ghc-$(ProjectVersion)/fptools/" | sort >$(FPTOOLS_TOP_ABS)/bin-manifest-$(ProjectVersion) )
-
-PUBLISH_FILES = $(BIN_DIST_TARBALL)
+PUBLISH_FILES = $(BIN_DIST_TAR_BZ2)
 
 # Upload the distribution and documentation
 ifneq "$(ISCC)" ""
@@ -467,7 +477,7 @@ binary-dist::
 
 ifeq "$(darwin_TARGET_OS)" "1"
 
-.PHONY: framework-pkg, framework-binary-dist
+.PHONY: framework-pkg framework-binary-dist
 
 framework-pkg:
        $(MAKE) -C distrib/MacOS framework-pkg
@@ -518,7 +528,7 @@ SRC_DIST_FILES += \
 #   - remove a bunch of other files that we know shouldn't be in the dist
 #   - tar up first the extralibs package, then the main source package
 
-EXTRA_LIBS=$(patsubst %, $(SRC_DIST_NAME)/libraries/%, $(shell cat libraries/extra-packages))
+EXTRA_LIBS=$(patsubst %, $(SRC_DIST_NAME)/%, $(shell grep -E "extralibs|dph" packages | grep -v "^\#" | sed "s/ .*//"))
 
 SRC_DIST_TARBALL = ghc-$(ProjectVersion)-src.tar.bz2
 SRC_DIST_EXTRALIBS_TARBALL = ghc-$(ProjectVersion)-src-extralibs.tar.bz2
@@ -528,6 +538,24 @@ VERSION :
 
 dist :: VERSION
 
+# Use:
+#     $(call copy_generated_compiler_file,cmm,CmmLex,x)
+# to copy the generated file that replaces compiler/cmm/CmmLex.x
+# XXX Should this be unconditional? Do we want to support making a src dist
+# from an unbuilt tree?
+copy_generated_compiler_file = \
+  if test -f $(FPTOOLS_TOP_ABS)/compiler/dist-stage2/build/$2.hs; \
+  then \
+    $(CP) $(FPTOOLS_TOP_ABS)/compiler/dist-stage2/build/$2.hs compiler/$1/ ; \
+    mv compiler/$1/$2.$3 compiler/$1/$2.$3.source ; \
+  fi
+copy_generated_util_file = \
+  if test -f $(FPTOOLS_TOP_ABS)/utils/$1/dist-install/build/$1/$1-tmp/$2.hs; \
+  then \
+    $(CP) $(FPTOOLS_TOP_ABS)/utils/$1/dist-install/build/$1/$1-tmp/$2.hs utils/$1/ ; \
+    mv utils/$1/$2.$3 utils/$1/$2.$3.source ; \
+  fi
+
 dist ::
        $(RM) -rf $(SRC_DIST_DIR)
        $(RM) $(SRC_DIST_NAME).tar.gz
@@ -537,12 +565,21 @@ dist ::
          && for i in $(SRC_DIST_FILES); do $(LN_S) $(FPTOOLS_TOP_ABS)/$$i .; done \
          && $(MAKE) distclean \
          && if test -f $(FPTOOLS_TOP_ABS)/libraries/haskell-src/dist/build/Language/Haskell/Parser.hs; then $(CP) $(FPTOOLS_TOP_ABS)/libraries/haskell-src/dist/build/Language/Haskell/Parser.hs libraries/haskell-src/Language/Haskell/ ; mv libraries/haskell-src/Language/Haskell/Parser.ly libraries/haskell-src/Language/Haskell/Parser.ly.source ; fi \
+         && $(call copy_generated_compiler_file,cmm,CmmLex,x) \
+         && $(call copy_generated_compiler_file,cmm,CmmParse,y) \
+         && $(call copy_generated_compiler_file,main,ParsePkgConf,y) \
+         && $(call copy_generated_compiler_file,parser,HaddockLex,x) \
+         && $(call copy_generated_compiler_file,parser,HaddockParse,y) \
+         && $(call copy_generated_compiler_file,parser,Lexer,x) \
+         && $(call copy_generated_compiler_file,parser,Parser,y.pp) \
+         && $(call copy_generated_compiler_file,parser,ParserCore,y) \
+         && $(call copy_generated_util_file,hpc,HpcParser,y) \
          && $(RM) -rf compiler/stage[123] mk/build.mk \
          && $(FIND) $(SRC_DIST_DIRS) \( -name _darcs -o -name SRC -o -name "autom4te*" -o -name "*~" -o -name ".cvsignore" -o -name "\#*" -o -name ".\#*" -o -name "log" -o -name "*-SAVE" -o -name "*.orig" -o -name "*.rej" \) -print | xargs $(RM) -rf \
        )
-       tar chf - $(EXTRA_LIBS) | bzip2 >$(FPTOOLS_TOP_ABS)/$(SRC_DIST_EXTRALIBS_TARBALL)
+       $(TAR) chf - $(EXTRA_LIBS) | bzip2 >$(FPTOOLS_TOP_ABS)/$(SRC_DIST_EXTRALIBS_TARBALL)
        $(RM) -rf $(EXTRA_LIBS)
-       tar chf - $(SRC_DIST_NAME) 2>$src_log | bzip2 >$(FPTOOLS_TOP_ABS)/$(SRC_DIST_TARBALL)
+       $(TAR) chf - $(SRC_DIST_NAME) 2>$src_log | bzip2 >$(FPTOOLS_TOP_ABS)/$(SRC_DIST_TARBALL)
 
 # Upload the distribution(s)
 # Retrying is to work around buggy firewalls that corrupt large file transfers
@@ -551,11 +588,11 @@ ifneq "$(PublishLocation)" ""
 dist ::
        @for i in 0 1 2 3 4 5 6 7 8 9; do \
                echo "Try $$i: $(PublishCp) $(SRC_DIST_EXTRALIBS_TARBALL) $(PublishLocation)/dist"; \
-               if $(PublishCp) $(SRC_DIST_EXTRALIBS_TARBALL) $(PublishLocation)/dist; then break; fi\
+               if $(PublishCp) $(SRC_DIST_EXTRALIBS_TARBALL) $(PublishLocation)/dist; then break; fi\
        done
        @for i in 0 1 2 3 4 5 6 7 8 9; do \
                echo "Try $$i: $(PublishCp) $(SRC_DIST_TARBALL) $(PublishLocation)/dist"; \
-               if $(PublishCp) $(SRC_DIST_TARBALL) $(PublishLocation)/dist; then break; fi\
+               if $(PublishCp) $(SRC_DIST_TARBALL) $(PublishLocation)/dist; then break; fi\
        done
 endif
 
@@ -570,7 +607,7 @@ hc-file-bundle :
             ghc-$(ProjectVersion)/libraries -follow \
          \( -name "*.hc" -o -name "*_hsc.[ch]" -o -name "*_stub.[ch]" \) -print > hc-files-to-go
        for f in `$(FIND) ghc-$(ProjectVersion)/compiler ghc-$(ProjectVersion)/utils ghc-$(ProjectVersion)/libraries -name "*.hsc" -follow -print` ""; do \
-            if test "x$$f" != "x" && test -e `echo "$$f" | sed 's/hsc$$/hs/g'`; then \
+            if test "x$$f" != "x" && test -f `echo "$$f" | sed 's/hsc$$/hs/g'`; then \
                echo `echo "$$f" | sed 's/hsc$$/hs/g' ` >> hc-files-to-go ; \
             fi; \
        done;
@@ -584,7 +621,7 @@ hc-file-bundle :
        echo ghc-$(ProjectVersion)/compiler/parser/ParserCore.hs >> hc-files-to-go
        echo ghc-$(ProjectVersion)/compiler/main/ParsePkgConf.hs >> hc-files-to-go
        echo ghc-$(ProjectVersion)/libraries/haskell-src/Language/Haskell/Parser.hs >> hc-files-to-go
-       tar czf ghc-$(ProjectVersion)-$(TARGETPLATFORM)-hc.tar.gz `cat hc-files-to-go`
+       $(TAR) czf ghc-$(ProjectVersion)-$(TARGETPLATFORM)-hc.tar.gz `cat hc-files-to-go`
 
 # -----------------------------------------------------------------------------
 # Cleaning